/*
 * BillingMaker.java
 *
 * Created on 10 de agosto de 2004, 18:15
 */

package com.fenalco.servlets.sysmanager;

import java.io.IOException;
import java.sql.Date;
import java.util.Enumeration;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.DataAccess;
import com.fenalco.entities.Log;
import com.fenalco.entities.Supplier;
import com.fenalco.entities.SupplierList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * 
 * @author andres
 * @version
 */
public class BillingMaker extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones de los mètodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * -Llama la función <CODE>makeBilling()</CODE> para generar las facturas
	 * en el sistema -Llama la función <CODE>makeBillingFile</CODE> para
	 * generar un archivo físico con las facturas -Redirecciona a
	 * descargarfactura.jsp con un mensaje de éxito
	 * 
	 * @param request
	 *            peticiòn al servlet
	 * @param response
	 *            respuesta del servlet
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		String message = "El proceso de facturación ha finalizado con éxito";

		String url = "/administrador/descargarfactura.jsp";
		HttpSession session = request.getSession(false);
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 1 )
			{
				url = "/index.jsp";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				if( makeBilling(request) )
				{
					Log log = new Log();
					String userId = ((User) session.getAttribute("user"))
							.getLogin();
					String numberId = ((User) session.getAttribute("user"))
							.getIdentificationNumber();
					String description = "Mes facturado->"
							+ request.getParameter("month") + "-"
							+ request.getParameter("year");
					Transaction t = new Transaction();
					log.saveData(userId, numberId, 20, description, "", t);
					t.execute();
	
					if( !makeBillingFile() )
					{
						//message="Error al crear el archivo con la facturación";
						url = "/administrador/listaproveedoresfacturacion";
					}
				}
				else
				{
					message = "Error al generar la facturación";
					url = "/administrador/listaproveedoresfacturacion";
				}
	
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el mètodo HTTP <code>GET</code>
	 * 
	 * @param request
	 *            peticiòn al servlet
	 * @param response
	 *            respuesta del servlet
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el mètodo HTTP <code>POST</code>
	 * 
	 * @param request
	 *            peticiòn al servlet
	 * @param response
	 *            respuesta del servlet
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una corta descripciòn del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

	/**
	 * Genera la facturación para todos los proveedores del sistema. Carga una
	 * lista de proveedores de tipo <CODE>SupplierList</CODE> y luego llama la
	 * función <CODE>makeBill()</CODE> de la clase <CODE>Supplier</CODE>
	 * para cada proveedor.
	 * 
	 * @return booleano que indica si el proceso de facturación fué exitoso
	 */
	public boolean makeBilling( HttpServletRequest request )
	{

		int year = Integer.parseInt(request.getParameter("year"));
		int month = Integer.parseInt(request.getParameter("month"));
		boolean success = false;

		Date date = new Date(0);
		date = Date.valueOf(year + "-" + month + "-" + "01");

		if( !DataAccess.monthInvoiced(date) )
		{
			SupplierList supplierList = new SupplierList();
			Enumeration e = supplierList.getSuppliers().elements();
			Transaction transaction = new Transaction();

			while( e.hasMoreElements() )
			{
				success = ((Supplier) e.nextElement()).makeBill(transaction,
						date);
				if( !success )
				{
					break;
				}
			}

			if( success )
			{
				success = transaction.execute();
			}
		}
		else
		{
			success = false;
		}
		return success;
	}

	/**
	 * Genera un archivo con la facturación actual
	 */
	public boolean makeBillingFile( )
	{
		return false;
	}

}